import base64
import json

class KeyManager(object):
    key_file = ''
    keys = {}
    user_file = ''
    users = {}

    def __init__(self, key_file, user_file):
       self.key_file = key_file 
       self.user_file = user_file
       self._read_keys()
       self._read_users()

    def set_key(self, file_id, keys):
        self.keys[unicode(file_id)] = {'key': base64.b64encode(keys['key']),
             'iv': base64.b64encode(keys['iv'])}
        self._write_keys()

    def set_user_key(self, username, key):
        self.users[unicode(username)] = base64.b64encode(key)
        self._write_users()

    def get_key(self, file_id):
        if unicode(file_id) in self.keys.keys():
            k = self.keys[unicode(file_id)]
            return {'key': base64.b64decode(k['key']),
                    'iv': base64.b64decode(k['iv'])}
        return None

    def get_user_key(self, username):
        if unicode(username) in self.users.keys():
            u = self.users[unicode(username)]
            return base64.b64decode(u)
        return None

    def _write_keys(self):
        try:
            f = open(self.key_file, 'w')
            f.write(json.dumps(self.keys))
            f.close()
        except IOError:
            print 'Could not write keys'
        except ValueError:
            print 'Could not encode keys'

    def _write_users(self):
        try:
            f = open(self.user_file, 'w')
            f.write(json.dumps(self.users))
            f.close()
        except IOError:
            print 'Could not write users'
        except ValueError:
            print 'Could not encode users'

    def _read_keys(self):
        try:
            f = open(self.key_file, 'r+')
            data = f.read()
            if len(data) > 0:
                self.keys = json.loads(data)
        except IOError:
            print 'Could not read keys'
        except ValueError:
            print 'Could not decode keys'

    def _read_users(self):
        try:
            f = open(self.user_file, 'r+')
            data = f.read()
            if len(data) > 0:
                self.users = json.loads(data)
        except IOError:
            print 'Could not read users'
        except ValueError:
            print 'Could not decode users'
